#include <signal.h>
#include <stdio.h>
#include <syslog.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

#include <proc.h>
#include <vcp.h>

int proc_kill( S_VCP_STATE *vs )
{
	if( vs->pid==0 ) return TRUE;

	if( kill( vs->pid, SIGTERM )!=0 ) return FALSE;

	if( waitpid( vs->pid, NULL, 0 )!=vs->pid ) return FALSE;

	syslog( LOG_INFO, "Process %d killed", vs->pid );

	vs->pid=0;

	return TRUE;
}

int proc_fork( S_VCP_STATE *vs )
{
	pid_t pid;

	switch(pid=fork()) {
		case -1:
			/* Parent with error */
			syslog( LOG_ERR, "Error doing fork." );
			return FALSE;

		case 0:
			/* Child */
			/* Call function */
			vs->func.intv( vs );
			break;

		default:
			/* Parent without error */
			syslog( LOG_INFO, "INTV process forked" );
			vs->pid=pid;
			break;
	}

	return TRUE;
}

